/*
 * Copyright (c) 2005 Marek Materzok
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

using Wraith;

module Example
{
    public Main() : void
    {
        def pt = parser[string] (
            number = ('+' | '-')! skip[true]( (:digit:)+ (',' (:digit:)+)! )
                -> <[ double.Parse(_matched()) : double ]>;
            fact = <[ mutable ret = 0 : double ]> -> 
                number <[ ret = number ]> 
                | '(' expr ')' <[ ret = expr ]> 
                | '-' fact <[ ret = -fact ]> 
                | '+' fact <[ ret = fact ]> 
                -> <[ (ret) : double ]>;
            term = <[ mutable ret = 1 : double ]> -> 
                fact <[ ret = fact ]> 
                    ( '*' fact <[ ret *= fact ]> 
                    | '/' fact <[ ret /= fact ]>
                    )* 
                -> <[ (ret) : double ]>;
            expr = <[ mutable ret = 0 : double ]> -> 
                term <[ ret = term ]>  
                    ( '+' term <[ ret += term ]> 
                    | '-' term <[ ret -= term ]>
                    )* 
                -> <[ (ret) : double ]>;
            main = expr endofinput -> <[ (expr) : double ]>;
            skipper = (' '*);
        );
        def p = pt();
        
        def l = System.Console.ReadLine();
        def (r, n) = p.ParseGet(l);

        if (n == l.Length)
            System.Console.WriteLine($"Result: $r");
        else
            System.Console.WriteLine("Error");
    }
};

